Package org.optaplanner.core.impl.score.stream.drools.common

## Class AbstractConstraintConsequence<LeftHandSide_ extends org.optaplanner.core.impl.score.stream.drools.common.AbstractLeftHandSide>

- java.lang.Object
- - org.optaplanner.core.impl.score.stream.drools.common.AbstractConstraintConsequence<LeftHandSide_>

-     public abstract class AbstractConstraintConsequence<LeftHandSide_ extends org.optaplanner.core.impl.score.stream.drools.common.AbstractLeftHandSide>
      extends Object

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AbstractConstraintConsequence()` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `<Solution_> RuleAssembly` | `assemble​(org.drools.model.Global<? extends AbstractScoreHolder<?>> scoreHolderGlobal, DroolsConstraint<Solution_> constraint)` |
    `protected abstract org.drools.model.consequences.ConsequenceBuilder.ValidBuilder` | `buildConsequence​(DroolsConstraint<?> constraint, org.drools.model.Global<? extends AbstractScoreHolder<?>> scoreHolderGlobal, org.drools.model.Variable<?>... variables)` |
    `abstract int` | `getCardinality()` |
    `protected Stream<Class<?>>` | `getExpectedJustificationTypes()` |
    `protected abstract LeftHandSide_` | `getLeftHandSide()` | The left hand side on which the consequence will be applied.
    `protected abstract org.optaplanner.core.impl.score.stream.drools.common.ConsequenceMatchWeightType` | `getMatchWeightType()` | The numeric type of the match weight that score will be impacted with.
    `protected static void` | `impactScore​(org.drools.model.Drools drools, AbstractScoreHolder<?> scoreHolder, Object... justifications)` |
    `protected static void` | `impactScore​(DroolsConstraint<?> constraint, org.drools.model.Drools drools, AbstractScoreHolder<?> scoreHolder, int impact, Object... justifications)` |
    `protected static void` | `impactScore​(DroolsConstraint<?> constraint, org.drools.model.Drools drools, AbstractScoreHolder<?> scoreHolder, long impact, Object... justifications)` |
    `protected static void` | `impactScore​(DroolsConstraint<?> constraint, org.drools.model.Drools drools, AbstractScoreHolder<?> scoreHolder, BigDecimal impact, Object... justifications)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AbstractConstraintConsequence

          public AbstractConstraintConsequence()

  - ### Method Detail

    - #### getLeftHandSide

          protected abstract LeftHandSide_ getLeftHandSide()

      The left hand side on which the consequence will be applied.
      Returns:
        never null

    - #### getMatchWeightType

          protected abstract org.optaplanner.core.impl.score.stream.drools.common.ConsequenceMatchWeightType getMatchWeightType()

      The numeric type of the match weight that score will be impacted with. See Javadoc for extending interfaces for more.
      Returns:
        never null

    - #### getCardinality

          public abstract int getCardinality()

    - #### buildConsequence

          protected abstract org.drools.model.consequences.ConsequenceBuilder.ValidBuilder buildConsequence​(DroolsConstraint<?> constraint,
                                                                                                            org.drools.model.Global<? extends AbstractScoreHolder<?>> scoreHolderGlobal,
                                                                                                            org.drools.model.Variable<?>... variables)

    - #### getExpectedJustificationTypes

          protected final Stream<Class<?>> getExpectedJustificationTypes()

    - #### assemble

          public final <Solution_> RuleAssembly assemble​(org.drools.model.Global<? extends AbstractScoreHolder<?>> scoreHolderGlobal,
                                                         DroolsConstraint<Solution_> constraint)

    - #### impactScore

          protected static void impactScore​(org.drools.model.Drools drools,
                                            AbstractScoreHolder<?> scoreHolder,
                                            Object... justifications)

    - #### impactScore

          protected static void impactScore​(DroolsConstraint<?> constraint,
                                            org.drools.model.Drools drools,
                                            AbstractScoreHolder<?> scoreHolder,
                                            int impact,
                                            Object... justifications)

    - #### impactScore

          protected static void impactScore​(DroolsConstraint<?> constraint,
                                            org.drools.model.Drools drools,
                                            AbstractScoreHolder<?> scoreHolder,
                                            long impact,
                                            Object... justifications)

    - #### impactScore

          protected static void impactScore​(DroolsConstraint<?> constraint,
                                            org.drools.model.Drools drools,
                                            AbstractScoreHolder<?> scoreHolder,
                                            BigDecimal impact,
                                            Object... justifications)